# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class Chat(UniversalBaseModel):
    """
    A chat conversation with associated metadata and settings.
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    ID of the chat.
    """

    first_query: typing.Optional[str] = pydantic.Field(default=None)
    """
    The first query of the chat.
    """

    first_answer: typing.Optional[str] = pydantic.Field(default=None)
    """
    The first answer of the chat.
    """

    enabled: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Indicates whether this chat is enabled and can have further turns.
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    Specifies when this chat was created.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
