# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel


class GenerationSpan(UniversalBaseModel):
    """
    The generation by an LLM.
    """

    type: typing.Literal["generation"] = "generation"
    latency_millis: typing.Optional[int] = pydantic.Field(default=None)
    """
    Time taken in milliseconds.
    """

    started_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    When the span started.
    """

    prompt: typing.Optional[str] = pydantic.Field(default=None)
    """
    The text sent as a prompt to the LLM.
    """

    generation: typing.Optional[str] = pydantic.Field(default=None)
    """
    The text generated from the LLM.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
