# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .individual_search_result import IndividualSearchResult
from .rewritten_query import RewrittenQuery


class StreamSearchResponse(UniversalBaseModel):
    """
    The search response results.
    """

    type: typing.Literal["search_results"] = "search_results"
    search_results: typing.Optional[typing.List[IndividualSearchResult]] = pydantic.Field(default=None)
    """
    The ranked search results.
    """

    rewritten_queries: typing.Optional[typing.List[RewrittenQuery]] = pydantic.Field(default=None)
    """
    The rewritten queries for the corpora that were searched. Only populated when 
    intelligent_query_rewriting is enabled.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
