# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from .table_extractor_spec import TableExtractorSpec
from .table_generation_spec import TableGenerationSpec


class TableExtractionConfig(UniversalBaseModel):
    """
    Configuration for table extraction from the document. This is optional and if not provided, the platform does not extract tables from PDF files.
    """

    extract_tables: bool = pydantic.Field()
    """
    If set to true, the platform will attempt to extract tables from the document.
    The tables will be indexed as separate document parts.
    """

    extractor: typing.Optional[TableExtractorSpec] = None
    generation: typing.Optional[TableGenerationSpec] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
